#!/bin/bash

# Generate committee-listing web page for the competition web site.

CATEGORY_STRUCTURE="benchmark-defs/category-structure.yml"
YEAR=$(yq --raw-output '.year' "$CATEGORY_STRUCTURE")
COMPETITIONNAME=$(yq --raw-output '.competition' "$CATEGORY_STRUCTURE")

echo "<!-- This is generated by $0. Do not change manually. -->";

ls -1 ./fm-tools/data/*.yml \
| grep -v "schema.yml" \
| xargs --replace=ARG yq -r '["ARG", .name, .project_url] | join(";")' ARG \
| sort \
| while IFS=';' read TOOLFILE TOOLNAME TOOLURL; do
  yq -r ".competition_participations []| select(.competition == \"$COMPETITIONNAME $YEAR\") | [.jury_member.name, .jury_member.institution, .jury_member.country, .jury_member.url] | join(\";\")" "$TOOLFILE" \
  | sort -u \
  | while IFS=';' read MEMBERNAME MEMBERINST MEMBERCOUNTRY MEMBERURL; do
  if [[ "$MEMBERNAME" == "Hors Concours" ]]; then
    continue
  fi
  TOOL=$(basename ${TOOLFILE%.yml})
  TOOLFUNC=${TOOL//[2]/two}
  TOOLFUNC=${TOOLFUNC//\-/}
  if [[ ! "$MEMBERNAME" =~ "Team" ]]; then
    echo "  <li>";
    if [[ -n "$MEMBERURL" ]]; then
      echo "    <a href=\"$MEMBERURL\">$MEMBERNAME</a>";
    else
      echo "    $MEMBERNAME ";
    fi
    echo "      (representing <?php ${TOOLFUNC,,}${YEAR}() ?>), $MEMBERINST, $MEMBERCOUNTRY";
    echo "  </li>";
  fi
    done
done
